// -----------------------------------------------------------------------
class Sor_Smooth{

   double relaxc(int nx, int ny, double u[][],double rhs[][],
                 double res[][], double h){

      double h2    = 1.0/( h * h);
      double jacel = (h * h)/ 4.0;
      double sum = 0.0;
   
      for (int i=1;i<nx-1;i++) {
         for (int j=1;j<ny-1;j++) {
   
            res[i][j] = h2 * ( u[i+1][j] + u[i-1][j] +
                               u[i][j+1] + u[i][j-1] -
                               4.0 * u[i][j] )  - rhs[i][j];
   
            u[i][j] += jacel * res[i][j];
            sum = sum + res[i][j] * res[i][j] ;
           } 
      }
      double sum2 = sum / nx / nx / ny / ny;
      double sum3 = Math.sqrt(sum2); 
   
      return sum3; 
   }

// -----------------------------------------------------------------------
	static void set_up_u(int nx, int ny, double u[][], double uxct[][], double h){
		double Pi = 3.1415926535897932 ;

      for (int j=0;j<ny;j++) {
         for (int i=0;i<nx;i++) {
            uxct[i][j] = Math.sin(Pi * (i-1)*h) *
                         Math.sin(Pi * (j-1)*h);
            u[i][j] = 0.0;
         }
      }
	}
// -----------------------------------------------------------------------
   static void set_up_rhs(int nx, int ny, double rhs[][], double uxct[][]){
      double Pi = 3.1415926535897932 ;

      for (int j=0;j<ny;j++) {
         for (int i=0;i<nx;i++) {
            rhs[i][j] = -Pi * Pi * uxct[i][j];
         }
      }
	}
// -----------------------------------------------------------------------

   public static void main (String args[]) {
      Sor_Smooth relax = new Sor_Smooth();
      int nx = 3  , ny = 3 ;
      int l = 0;

	   nx = Integer.parseInt(args[0]);
	   ny = Integer.parseInt(args[1]);

      double u[][] = new double[nx][ny];
		double rhs[][] = new double[nx][ny];
		double res[][] = new double[nx][ny];
		double uxct[][] = new double[nx][ny];
      double l2;
      double h;
		double error;
      double eps = 0.000001;
   
      int i,j;
   
      h = 1.0 / (nx - 1);

		set_up_u(nx,ny,u,uxct,h);
		set_up_rhs(nx,ny,rhs,uxct);
   
      for (i=0;i<nx;i++) {
         u[i][0] = uxct[i][0];
         u[i][ny-1] = uxct[i][ny-1];
      }
      for (j=0;i<ny;j++) {
         u[0][j] = uxct[0][j];
         u[nx-1][j] = uxct[nx-1][j];
      }
   
       
      l2 = relax.relaxc(nx,ny,u,rhs,res,h);
      while ( l2 > eps) {
         l ++;
         l2 = relax.relaxc(nx,ny,u,rhs,res,h);
         if (l % 100 == 0 ) {
            System.out.println("Iteration " + l + "norm = " + l2); 
				error = 0.0;
				for (i=0;i<nx;i++) {
				for (j=0;j<ny;j++) {
					error = error + Math.abs(u[i][j]-uxct[i][j]);
				}
				}
				error = error / nx / ny;
            System.out.println("Error " + error); 
         }
      }
         System.out.println("Iteration " + l + "norm = " + l2); 
   }

}
